﻿using System;
using System.Text;
using System.Diagnostics;

namespace madd_cs
{
    class Program
    {
        static void Main(string[] args)
        {
            short[] a = new short[256];
            short[] b = new short[256];
            for (int i = 0; i < 256; i++)
            {
                a[i] = (short)(i & 1);
                b[i] = (short)(i & 3);
            }

            int mn = 100500;
            Stopwatch sw = new Stopwatch();
            sw.Start();
            for (int n = 0; n < 10000000; n++)
            {
                int sum = 0, j = 0;
                //for (int j = 0; j < 256; j++)   {
                for(int y=0;y<16;y++)
                    for(int x=0;x<16;x++) {		
                        short v = (short)(a[j] - b[j]);
                        sum += v * v;
                        j++;
                }
                mn = mn < sum ? mn : sum;
            }
            sw.Stop();
            Console.WriteLine("{0} {1}", mn, sw.ElapsedMilliseconds);
        }
    }
}
