#include "stdafx.h"
#include <windows.h>
#include <emmintrin.h>
int main(int argc, char* argv[])
{
	__declspec(align(16)) short a[256], b[256];
	for(int i=0;i<256;i++) {
		a[i] = i & 1;
		b[i] = i & 3;
	}
	LARGE_INTEGER t0, t1, fr;	
	int mn = 100500;
	QueryPerformanceCounter(&t0);
	for(int n=0;n<10000000;n++) {
		int sum = 0, j=0;
		/*for(int y=0;y<16;y++)
			for(int x=0;x<16;x++) {		
				short v = a[j] - b[j];
				sum += v*v;
				j++;
			}*/
		__m128i xsum = _mm_setzero_si128();
		while(j<256) {
			__m128i a16 = _mm_load_si128((__m128i*)&a[j]);
			__m128i b16 = _mm_load_si128((__m128i*)&b[j]);
			__m128i diff16 = _mm_sub_epi16(a16, b16);
			__m128i madd = _mm_madd_epi16(diff16, diff16);
			xsum = _mm_add_epi32(xsum, madd);
			j += 8;
		}
		__m128i shft = _mm_srli_si128(xsum, 8);
		xsum = _mm_add_epi32(xsum, shft);
		shft = _mm_srli_si128(xsum, 4);
		xsum = _mm_add_epi32(xsum, shft);
		sum = _mm_cvtsi128_si32(xsum);

		mn = mn < sum ? mn : sum;
	}
	QueryPerformanceCounter(&t1);
	QueryPerformanceFrequency(&fr);
	double t = (double)(t1.QuadPart - t0.QuadPart) / fr.QuadPart;
	printf("%d t=%.3lf\n", mn, t);
	return 0;
}

